import string
import secrets

from mongo.get_conn import db_conn

class pool_data:
    """
    This class will allow us to
    interact with our data to interact
    just create a pool_data var
    """
    def __init__(self):
        #db_conn has all the the things
        #already created from here 
        #we can get self.db.real_db etc 
        self.db = db_conn()
    def record_exists(self, date, test_user):
        """
            This function will accept an address
            if it find that address in the database it will return True
            and set set the existing_record variable of the class to the 
            queried record
        """
        query = { "date" : f"{date}", "test_user": f"{test_user}"}
        record = self.db.pool_db.find_one(query)
        if record:
            self.existing_record = record
            return True
        else:
            return False


    def create_re_record(self, ph, total_chlorine, free_chlorine, alkalinity, 
                         date, test_user, temp, hardness, stabiliser, salt="", comment=""):
        """
            create_re_record creates a whole new record
            takes the required 7 inputs
            1. ph
            2. total_chlorine
            3. free_chlorine
            4. alkalinity
            5. date
            6. test_user
            7. temp
            8. hardness
            9. stabiliser
            9. salt (optional)
            10. comment(optional)
            It will autogenerate the id string
            this string will be automatically selected
            on view in future
        """
        key = self.create_id()
        insert_record = {
                "_id" : f"{key}",
                "ph": f"{ph}",
                "total_chlorine": f"{total_chlorine}",
                "free_chlorine": f"{free_chlorine}",
                "alkalinity": f"{alkalinity}",
                "salt": f"{salt}",
                "temp": f"{temp}",
                "hardness": f"{hardness}",
                "stabiliser": f"{stabiliser}",
                "date": f"{date}",
                "test_user": f"{test_user}",
                "comment": f"{comment}"

                }
        self.db.pool_db.insert_one(insert_record)

    def update_re_record(self, id, field, value):
        """
            update_re_record
            will update the requested field to value for the
            selected field 
        """
        #TODO: do we need to make this take more than 1 id?

        query = { "_id": f"{id}"}
        update_val = {"$set": {f"{field}": f"{value}" }}
        self.db.pool_db.update_one(query, update_val)

    def create_id(self):
        alphabet = string.ascii_letters + string.digits
        key = ''.join(secrets.choice(alphabet) for _ in range(24))
        return key

